Bug 1265628 - Review Request: dhcpcd - A minimalistic network configuration daemon with DHCP and rdisc support
Review Request: dhcpcd - A minimalistic network configuration daemon with DHC...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Tomáš Hozza
Fedora Extras Quality Assurance
:
: 1272115 (view as bug list)
Depends On:
Blocks: dualstack
  Show dependency treegraph
 
Reported: 2015-09-23 07:36 EDT by Pavel Šimerda (pavlix)
Modified: 2016-02-19 03:36 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-02-19 03:36:32 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
thozza: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Pavel Šimerda (pavlix) 2015-09-23 07:36:40 EDT
Spec URL: http://pavlix.fedorapeople.org//dhcpcd.spec
SRPM URL: http://pavlix.fedorapeople.org//dhcpcd-6.9.3-1.fc24.src.rpm

Description:
The dhcpcd package provides a minimalistic network configuration daemon
that supports IPv4 and IPv6 configuration including configuration discovery
through NDP, DHCPv4 and DHCPv6 protocols.
Comment 1 Christopher Meng 2015-09-23 11:30:59 EDT
I'd packaged this for about 3 years, in the past it works on box of other distros.
Comment 2 Pavel Šimerda (pavlix) 2015-09-23 11:43:36 EDT
(In reply to Christopher Meng from comment #1)
> I'd packaged this for about 3 years, in the past it works on box of other
> distros.

So why is it not present in Fedora? Can you contact me on IRC?
Comment 3 Pavel Šimerda (pavlix) 2015-09-24 07:51:24 EDT
Rationale for inclusion in Fedora:

In my opinion the dhcpcd package is an important software for testing. It helps  testing to what extent a network is ready for IPv4 and IPv6 and getting all the necessary information. In many test scenarios it may be easier to operate than the full NetworkManager configuration stack. I don't have ambitions to judge whether someone will find it useful in production.
Comment 4 Christopher Meng 2015-09-24 08:23:13 EDT
1. Drop:

group: System Environment/Daemons

2. Source0: http://roy.marples.name/downloads/dhcpcd/dhcpcd-6.9.3.tar.xz

Better: Source0: http://roy.marples.name/downloads/dhcpcd/dhcpcd-%{version}.tar.xz

3. Reason? Or for fun?

echo y
echo x

4. find %{buildroot} -name '*.la' -delete

->

find %{buildroot} -name '*.la' -delete -print


5. %config /etc/dhcpcd.conf

No %config(noreplace)?

6. Please substitute paths with macros, %{_libexecdir}, %{_sbindir}, %{_datadir}, %{_mandir}.


(In reply to Pavel Šimerda (pavlix) from comment #2)
> (In reply to Christopher Meng from comment #1)
> > I'd packaged this for about 3 years, in the past it works on box of other
> > distros.
> 
> So why is it not present in Fedora? Can you contact me on IRC?

No comment. :)
Comment 5 Pavel Šimerda (pavlix) 2015-09-30 08:19:56 EDT
(In reply to Christopher Meng from comment #4)
> 1. Drop:
> 
> group: System Environment/Daemons

Fixed wrong case. According to guidelines Group seems to be needed for EPEL compatibility, right? I want to make dhcpcd as widely available as possible so I'll be definitely asking for EPEL6 and EPEL7 branches as well.

> 2. Source0: http://roy.marples.name/downloads/dhcpcd/dhcpcd-6.9.3.tar.xz
> 
> Better: Source0:
> http://roy.marples.name/downloads/dhcpcd/dhcpcd-%{version}.tar.xz

Sure.

> 3. Reason? Or for fun?
> 
> echo y
> echo x

Debugging cruft, got rid of it.

> 4. find %{buildroot} -name '*.la' -delete
> 
> ->
> 
> find %{buildroot} -name '*.la' -delete -print

Not sure why would you need to print those, especially in a way that doesn't suggest what's happening with them.
 
> 5. %config /etc/dhcpcd.conf
> 
> No %config(noreplace)?

Definitely.

> 6. Please substitute paths with macros, %{_libexecdir}, %{_sbindir},
> %{_datadir}, %{_mandir}.

Must have been really tired, sorry. 

> (In reply to Pavel Šimerda (pavlix) from comment #2)
> > (In reply to Christopher Meng from comment #1)
> > > I'd packaged this for about 3 years, in the past it works on box of other
> > > distros.
> > 
> > So why is it not present in Fedora? Can you contact me on IRC?
> 
> No comment. :)

Oh, well.
Comment 6 Upstream Release Monitoring 2015-09-30 10:00:38 EDT
pavlix's scratch build of dhcpcd-6.9.3-2.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=11277666
Comment 7 Upstream Release Monitoring 2015-09-30 10:47:02 EDT
pavlix's scratch build of dhcpcd-6.9.3-2.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11278201
Comment 8 Pavel Šimerda (pavlix) 2015-10-15 10:06:24 EDT
*** Bug 1272115 has been marked as a duplicate of this bug. ***
Comment 9 Upstream Release Monitoring 2015-10-15 10:06:49 EDT
pavlix's scratch build of dhcpcd-6.9.3-2.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11460080
Comment 10 Pavel Šimerda (pavlix) 2015-10-15 10:06:51 EDT
Spec URL: http://pavlix.fedorapeople.org//dhcpcd.spec
SRPM URL: http://pavlix.fedorapeople.org//dhcpcd-6.9.3-2.fc24.src.rpm

Description:
The dhcpcd package provides a minimalistic network configuration daemon
that supports IPv4 and IPv6 configuration including configuration discovery
through NDP, DHCPv4 and DHCPv6 protocols.
Comment 11 Upstream Release Monitoring 2015-10-15 10:08:12 EDT
pavlix's scratch build of dhcpcd-6.9.3-2.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11460085
Comment 12 Christopher Meng 2015-10-26 09:28:26 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



Issues:
=======
- Permissions on files are set properly.
  Note: See rpmlint output
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Public domain", "BSD (3
     clause)", "BSD (2 clause) ISC", "ISC", "BSD (2 clause)". 30 files have
     unknown license. Detailed output of licensecheck:

*No copyright* Public domain
----------------------------
dhcpcd-6.9.3/crypt/md5.c
dhcpcd-6.9.3/crypt/md5.h

BSD (2 clause)
--------------
dhcpcd-6.9.3/arp.c
dhcpcd-6.9.3/arp.h
dhcpcd-6.9.3/auth.c
dhcpcd-6.9.3/auth.h
dhcpcd-6.9.3/common.c
dhcpcd-6.9.3/common.h
dhcpcd-6.9.3/compat/arc4random.h
dhcpcd-6.9.3/compat/arc4random_uniform.h
dhcpcd-6.9.3/compat/closefrom.c
dhcpcd-6.9.3/compat/closefrom.h
dhcpcd-6.9.3/compat/dprintf.c
dhcpcd-6.9.3/compat/dprintf.h
dhcpcd-6.9.3/compat/endian.h
dhcpcd-6.9.3/compat/getline.c
dhcpcd-6.9.3/compat/getline.h
dhcpcd-6.9.3/compat/posix_spawn.c
dhcpcd-6.9.3/compat/posix_spawn.h
dhcpcd-6.9.3/compat/strlcpy.c
dhcpcd-6.9.3/compat/strlcpy.h
dhcpcd-6.9.3/compat/strtoi.c
dhcpcd-6.9.3/compat/strtoi.h
dhcpcd-6.9.3/control.c
dhcpcd-6.9.3/control.h
dhcpcd-6.9.3/crypt/crypt.h
dhcpcd-6.9.3/crypt/hmac_md5.c
dhcpcd-6.9.3/crypt/sha256.c
dhcpcd-6.9.3/crypt/sha256.h
dhcpcd-6.9.3/defs.h
dhcpcd-6.9.3/dev.c
dhcpcd-6.9.3/dev.h
dhcpcd-6.9.3/dev/udev.c
dhcpcd-6.9.3/dhcp-common.c
dhcpcd-6.9.3/dhcp-common.h
dhcpcd-6.9.3/dhcp.c
dhcpcd-6.9.3/dhcp.h
dhcpcd-6.9.3/dhcp6.c
dhcpcd-6.9.3/dhcp6.h
dhcpcd-6.9.3/dhcpcd-embedded.h.in
dhcpcd-6.9.3/dhcpcd-run-hooks.8.in
dhcpcd-6.9.3/dhcpcd.8.in
dhcpcd-6.9.3/dhcpcd.c
dhcpcd-6.9.3/dhcpcd.conf.5.in
dhcpcd-6.9.3/dhcpcd.h
dhcpcd-6.9.3/duid.c
dhcpcd-6.9.3/duid.h
dhcpcd-6.9.3/eloop.c
dhcpcd-6.9.3/eloop.h
dhcpcd-6.9.3/if-bsd.c
dhcpcd-6.9.3/if-linux-wext.c
dhcpcd-6.9.3/if-linux.c
dhcpcd-6.9.3/if-options.c
dhcpcd-6.9.3/if-options.h
dhcpcd-6.9.3/if-sun.c
dhcpcd-6.9.3/if.c
dhcpcd-6.9.3/if.h
dhcpcd-6.9.3/ipv4.c
dhcpcd-6.9.3/ipv4.h
dhcpcd-6.9.3/ipv4ll.c
dhcpcd-6.9.3/ipv4ll.h
dhcpcd-6.9.3/ipv6.c
dhcpcd-6.9.3/ipv6.h
dhcpcd-6.9.3/ipv6nd.c
dhcpcd-6.9.3/ipv6nd.h
dhcpcd-6.9.3/script.c
dhcpcd-6.9.3/script.h
dhcpcd-6.9.3/test/test.c
dhcpcd-6.9.3/test/test.h
dhcpcd-6.9.3/test/test_hmac_md5.c

BSD (2 clause) ISC
------------------
dhcpcd-6.9.3/bpf-filter.h

BSD (3 clause)
--------------
dhcpcd-6.9.3/compat/queue.h

ISC
---
dhcpcd-6.9.3/compat/arc4random_uniform.c

Unknown or generated
--------------------
dhcpcd-6.9.3/GNUmakefile
dhcpcd-6.9.3/Makefile
dhcpcd-6.9.3/Makefile.inc
dhcpcd-6.9.3/README
dhcpcd-6.9.3/compat/arc4random.c
dhcpcd-6.9.3/config-null.mk
dhcpcd-6.9.3/configure
dhcpcd-6.9.3/dev/Makefile
dhcpcd-6.9.3/dhcpcd-definitions.conf
dhcpcd-6.9.3/dhcpcd-embedded.c.in
dhcpcd-6.9.3/dhcpcd-hooks/01-test
dhcpcd-6.9.3/dhcpcd-hooks/02-dump
dhcpcd-6.9.3/dhcpcd-hooks/10-wpa_supplicant
dhcpcd-6.9.3/dhcpcd-hooks/15-timezone
dhcpcd-6.9.3/dhcpcd-hooks/20-resolv.conf
dhcpcd-6.9.3/dhcpcd-hooks/29-lookup-hostname
dhcpcd-6.9.3/dhcpcd-hooks/30-hostname
dhcpcd-6.9.3/dhcpcd-hooks/50-dhcpcd-compat
dhcpcd-6.9.3/dhcpcd-hooks/50-ntp.conf
dhcpcd-6.9.3/dhcpcd-hooks/50-yp.conf
dhcpcd-6.9.3/dhcpcd-hooks/50-ypbind.in
dhcpcd-6.9.3/dhcpcd-hooks/GNUmakefile
dhcpcd-6.9.3/dhcpcd-hooks/Makefile
dhcpcd-6.9.3/dhcpcd-run-hooks.in
dhcpcd-6.9.3/dhcpcd.conf
dhcpcd-6.9.3/genembedc
dhcpcd-6.9.3/genembedh
dhcpcd-6.9.3/iconfig.mk
dhcpcd-6.9.3/test/GNUmakefile
dhcpcd-6.9.3/test/Makefile

[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/libexec/dhcpcd-hooks
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/libexec/dhcpcd-hooks
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[!]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: dhcpcd-6.9.3-2.fc24.i686.rpm
          dhcpcd-6.9.3-2.fc24.src.rpm
dhcpcd.i686: W: spelling-error Summary(en_US) minimalistic -> minimalist, minimalism, animistic
dhcpcd.i686: W: spelling-error Summary(en_US) rdisc -> disc, r disc
dhcpcd.i686: W: spelling-error %description -l en_US minimalistic -> minimalist, minimalism, animistic
dhcpcd.i686: W: unstripped-binary-or-object /usr/sbin/dhcpcd
dhcpcd.i686: E: non-standard-executable-perm /usr/libexec/dhcpcd-run-hooks 555
dhcpcd.i686: E: non-standard-executable-perm /usr/sbin/dhcpcd 555
dhcpcd.src: W: spelling-error Summary(en_US) minimalistic -> minimalist, minimalism, animistic
dhcpcd.src: W: spelling-error Summary(en_US) rdisc -> disc, r disc
dhcpcd.src: W: spelling-error %description -l en_US minimalistic -> minimalist, minimalism, animistic
dhcpcd.src: W: no-%build-section
2 packages and 0 specfiles checked; 2 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
INFO: mock.py version 1.2.13 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux disabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.13
INFO: Mock Version: 1.2.13
Finish: chroot init
INFO: installing package(s): rpmlint
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-i386/root/ --releasever 24 install rpmlint



Requires
--------
dhcpcd (rpmlib, GLIBC filtered):
    /bin/sh
    /sbin/ldconfig
    config(dhcpcd)
    libc.so.6
    rtld(GNU_HASH)



Provides
--------
dhcpcd:
    config(dhcpcd)
    dhcpcd
    dhcpcd(x86-32)



Source checksums
----------------
http://roy.marples.name/downloads/dhcpcd/dhcpcd-6.9.3.tar.xz :
  CHECKSUM(SHA256) this package     : 6089471ed695fa62ac8351466b96b4b6365fd14ec455a120a6524663808eae53
  CHECKSUM(SHA256) upstream package : 6089471ed695fa62ac8351466b96b4b6365fd14ec455a120a6524663808eae53


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/bin/fedora-review -rvn dhcpcd-6.9.3-2.fc24.src.rpm
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

----------------------------------------------------------------
Well,

1. Checking for libudev ... no
Checking for ntpd ... not found
Checking for ypbind ... not found

i.  Systemd dev packages required.

---Attention---

1. Make sure you have correct systemd scriptlets, it's important.

2. Make sure you have elegant systemd unit files, means it doesn't hurt user experience during upgrade.

3. Make sure you have units for all interfaces / single interface, this means you need to create dhcpcd.service and dhcpcd@.service.

ii. Also consider adding ntp hook.

2. Where is build section?

3. EPEL7 doesn't requires Group tag.

4. dhcpcd.i686: E: non-standard-executable-perm /usr/libexec/dhcpcd-run-hooks 555
dhcpcd.i686: E: non-standard-executable-perm /usr/sbin/dhcpcd 555

Why not 755? Lying in /sbin doesn't mean 555 is OK.

5. Haven't specify dbdir in %configure, if you insist on keeping the default path, then include it in %files, by %ghost, %dir (mkdir in %install, then include it in %files, or other ways you like)

6. `make test` please.

7. %post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

You are confusing yourself, ldconfig shouldn't be called because dhcpcd doesn't have libraries.

8. You need to make sure ipv4all and duid are disabled, for reasons behind:

i.  0conf sucks

ii. DHCP Unique Identifier sucks in many environments which don't have ipv6 enabled.

9. /etc -> %{_sysconfdir} in %files.

------------------------------

Just out of curiosity, have you ever used it? From the spec I couldn't parse, too opaque. ;)
Comment 13 Upstream Release Monitoring 2015-11-11 10:53:55 EST
pavlix's scratch build of dhcpcd-6.9.3-2.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=11794893
Comment 14 Upstream Release Monitoring 2015-11-11 11:04:39 EST
pavlix's scratch build of dhcpcd-6.9.3-2.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=11794982
Comment 15 Upstream Release Monitoring 2015-11-11 11:36:10 EST
pavlix's scratch build of dhcpcd-6.9.3-2.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11795270
Comment 16 Pavel Šimerda (pavlix) 2015-11-11 13:07:29 EST
Spec URL: http://pavlix.fedorapeople.org//dhcpcd.spec
SRPM URL: http://pavlix.fedorapeople.org//dhcpcd-6.9.3-3.fc24.src.rpm

Description:
The dhcpcd package provides a minimalistic network configuration daemon
that supports IPv4 and IPv6 configuration including configuration discovery
through NDP, DHCPv4 and DHCPv6 protocols.
Comment 17 Pavel Šimerda (pavlix) 2015-11-11 13:10:58 EST
The above (In reply to Pavel Šimerda (pavlix) from comment #16)
> Spec URL: http://pavlix.fedorapeople.org//dhcpcd.spec
> SRPM URL: http://pavlix.fedorapeople.org//dhcpcd-6.9.3-3.fc24.src.rpm

Not yet final, please wait for another respin.
Comment 18 Michael Schwendt 2015-11-11 13:16:46 EST
> Not yet final, please wait for another respin.

Better pay attention to the bottom of comment 12 because your package contains several very unusual things that are severe mistakes.
Comment 19 Upstream Release Monitoring 2015-11-11 13:50:47 EST
pavlix's scratch build of dhcpcd-6.9.3-3.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=11796361
Comment 20 Upstream Release Monitoring 2015-11-11 13:52:44 EST
pavlix's scratch build of dhcpcd-6.9.3-3.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=11796370
Comment 21 Upstream Release Monitoring 2015-11-11 14:01:41 EST
pavlix's scratch build of dhcpcd-6.9.3-3.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11796403
Comment 22 Pavel Šimerda (pavlix) 2015-11-11 17:03:06 EST
(In reply to Christopher Meng from comment #12)
> [!]: Package requires other packages for directories it uses.
>      Note: No known owner of /usr/libexec/dhcpcd-hooks
> [!]: Package must own all directories that it creates.
>      Note: Directories without known owners: /usr/libexec/dhcpcd-hooks

It's now in %files.

> [!]: Package contains systemd file(s) if in need.

Added a dhcpcd.service.

> [!]: %check is present and all tests pass.

Added %check.

> Checking: dhcpcd-6.9.3-2.fc24.i686.rpm
>           dhcpcd-6.9.3-2.fc24.src.rpm
> dhcpcd.i686: W: spelling-error Summary(en_US) minimalistic -> minimalist,
> minimalism, animistic
> dhcpcd.i686: W: spelling-error Summary(en_US) rdisc -> disc, r disc
> dhcpcd.i686: W: spelling-error %description -l en_US minimalistic ->
> minimalist, minimalism, animistic

Looks ok.

> dhcpcd.i686: W: unstripped-binary-or-object /usr/sbin/dhcpcd

Shouldn't that be handled automatically by the debuginfo logic?

> dhcpcd.i686: E: non-standard-executable-perm /usr/libexec/dhcpcd-run-hooks
> 555
> dhcpcd.i686: E: non-standard-executable-perm /usr/sbin/dhcpcd 555

Fixed by BINDIR variable assignment.

> dhcpcd.src: W: spelling-error Summary(en_US) minimalistic -> minimalist,
> minimalism, animistic
> dhcpcd.src: W: spelling-error Summary(en_US) rdisc -> disc, r disc
> dhcpcd.src: W: spelling-error %description -l en_US minimalistic ->
> minimalist, minimalism, animistic

Looks ok.

> dhcpcd.src: W: no-%build-section

Fixed.

> Well,
> 
> 1. Checking for libudev ... no
> Checking for ntpd ... not found
> Checking for ypbind ... not found

I see. Well, we need some dependencies.

> i.  Systemd dev packages required.
> 
> ---Attention---
> 
> 1. Make sure you have correct systemd scriptlets, it's important.
> 
> 2. Make sure you have elegant systemd unit files, means it doesn't hurt user
> experience during upgrade.

Done.

> 3. Make sure you have units for all interfaces / single interface, this
> means you need to create dhcpcd.service and dhcpcd@.service.

I'm now only interested in dhcpcd.service for now. Let's talk about it later.

> ii. Also consider adding ntp hook.

Possibly.

> 2. Where is build section?

Fixed.

> 3. EPEL7 doesn't requires Group tag.

Removed.

> 4. dhcpcd.i686: E: non-standard-executable-perm
> /usr/libexec/dhcpcd-run-hooks 555
> dhcpcd.i686: E: non-standard-executable-perm /usr/sbin/dhcpcd 555
> 
> Why not 755? Lying in /sbin doesn't mean 555 is OK.

Fixed.

> 5. Haven't specify dbdir in %configure, if you insist on keeping the default
> path, then include it in %files, by %ghost, %dir (mkdir in %install, then
> include it in %files, or other ways you like)

I don't insist on it. Fixed.

> 6. `make test` please.

Fixed.

> 7. %post -p /sbin/ldconfig
> %postun -p /sbin/ldconfig
> 
> You are confusing yourself, ldconfig shouldn't be called because dhcpcd
> doesn't have libraries.

Fixed.

> 8. You need to make sure ipv4all and duid are disabled, for reasons behind:
> 
> i.  0conf sucks
>
> ii. DHCP Unique Identifier sucks in many environments which don't have ipv6
> enabled.

Let's discuss the details after the review with a wider group of participants, especially maintainers of the existing DHCP packages in Fedora.

> 9. /etc -> %{_sysconfdir} in %files.

Fixed.

> Just out of curiosity, have you ever used it? From the spec I couldn't
> parse, too opaque. ;)

I'm using dhcpcd both for testing local DHCP configuration and on some Gentoo hosts as a network configurator. My motivation to add it to Fedora is...

https://fedoraproject.org/wiki/QA/Networking

I need something that can easily test IPv4/IPv6 autoconfiguration and also provide a simple alternative to NetworkManager for testing scenarios as well as an alternative implementation to be compared to.

I just talked to the upstream developer and he's working on dhcpcd-online working just like nm-online or systemd-networkd-wait-online.
Comment 23 Upstream Release Monitoring 2015-11-11 17:49:56 EST
pavlix's scratch build of dhcpcd-6.9.3-4.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11797333
Comment 24 Pavel Šimerda (pavlix) 2015-11-24 10:59:39 EST
Spec URL: http://pavlix.fedorapeople.org//dhcpcd.spec
SRPM URL: http://pavlix.fedorapeople.org//dhcpcd-6.9.3-4.fc24.src.rpm

Description:
The dhcpcd package provides a minimalistic network configuration daemon
that supports IPv4 and IPv6 configuration including configuration discovery
through NDP, DHCPv4 and DHCPv6 protocols.
Comment 25 Tomáš Hozza 2016-01-04 04:39:40 EST
Pavel, I think you can try to poke the reviewer over email if he is still interested in the review. If he is not or does not respond within reasonable time, I think you can clear the reviewer (or reassign it to someone else).
Comment 26 Pavel Šimerda (pavlix) 2016-01-11 06:10:27 EST
We need to get this package to Fedora for IPv6 testing[1] and the reviewer is not responding in bugzilla nor in e-mails. Resetting assignee.

[1] https://fedoraproject.org/wiki/QA/Networking
Comment 27 Tomáš Hozza 2016-01-25 07:07:41 EST
- (In reply to Pavel Šimerda (pavlix) from comment #22)
> (In reply to Christopher Meng from comment #12)
> > 3. Make sure you have units for all interfaces / single interface, this
> > means you need to create dhcpcd.service and dhcpcd@.service.
> 
> I'm now only interested in dhcpcd.service for now. Let's talk about it later.

I think you should add also include the template unit for per-interface use for reasons described in https://wiki.archlinux.org/index.php/dhcpcd#dhcpcd_and_systemd_network_interfaces

It may not be your intended use-case, but the package will be available for all users in the distributions, therefore should be usable also for others.


Also "%{_var}/lib/" -> "%{_sharedstatedir}"


I'll add the full review of the latest SRPM shortly.
Comment 28 Upstream Release Monitoring 2016-01-25 10:34:47 EST
thozza's scratch build of dhcpcd-6.9.3-4.fc24.src.rpm for f24 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12677687
Comment 29 Tomáš Hozza 2016-01-25 10:44:07 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
     - According to https://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Systemd you should also BuildRequire "systemd".
[x]: Spec file is legible and written in American English.
[!]: Package contains systemd file(s) if in need.
     - Please add also the template unit dhcpcd@.service
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[?]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[!]: Latest version is packaged.
     - latest version is 6.10.1
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: dhcpcd-6.9.3-4.fc22.x86_64.rpm
          dhcpcd-6.9.3-4.fc22.src.rpm
dhcpcd.x86_64: W: spelling-error Summary(en_US) minimalistic -> minimalist, minimalism, animistic
dhcpcd.x86_64: W: spelling-error Summary(en_US) rdisc -> disc, r disc
dhcpcd.x86_64: E: summary-too-long C A minimalistic network configuration daemon with DHCPv4, rdisc and DHCPv6 support
dhcpcd.x86_64: W: spelling-error %description -l en_US minimalistic -> minimalist, minimalism, animistic
dhcpcd.src: W: spelling-error Summary(en_US) minimalistic -> minimalist, minimalism, animistic
dhcpcd.src: W: spelling-error Summary(en_US) rdisc -> disc, r disc
dhcpcd.src: E: summary-too-long C A minimalistic network configuration daemon with DHCPv4, rdisc and DHCPv6 support
dhcpcd.src: W: spelling-error %description -l en_US minimalistic -> minimalist, minimalism, animistic
2 packages and 0 specfiles checked; 2 errors, 6 warnings.




Rpmlint (debuginfo)
-------------------
Checking: dhcpcd-debuginfo-6.9.3-4.fc22.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
dhcpcd.x86_64: W: spelling-error Summary(en_US) minimalistic -> minimalist, minimalism, animistic
dhcpcd.x86_64: W: spelling-error Summary(en_US) rdisc -> disc, r disc
dhcpcd.x86_64: E: summary-too-long C A minimalistic network configuration daemon with DHCPv4, rdisc and DHCPv6 support
dhcpcd.x86_64: W: spelling-error %description -l en_US minimalistic -> minimalist, minimalism, animistic
2 packages and 0 specfiles checked; 1 errors, 3 warnings.



Requires
--------
dhcpcd (rpmlib, GLIBC filtered):
    /bin/sh
    config(dhcpcd)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libudev.so.1()(64bit)
    libudev.so.1(LIBUDEV_183)(64bit)
    rtld(GNU_HASH)
    systemd



Provides
--------
dhcpcd:
    config(dhcpcd)
    dhcpcd
    dhcpcd(x86-64)



Unversioned so-files
--------------------
dhcpcd: /usr/lib64/dhcpcd/dev/udev.so

Source checksums
----------------
http://roy.marples.name/downloads/dhcpcd/dhcpcd-6.9.3.tar.xz :
  CHECKSUM(SHA256) this package     : 6089471ed695fa62ac8351466b96b4b6365fd14ec455a120a6524663808eae53
  CHECKSUM(SHA256) upstream package : 6089471ed695fa62ac8351466b96b4b6365fd14ec455a120a6524663808eae53


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1265628
Buildroot used: fedora-22-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


Issues
------
[!]: Requires correct, justified where necessary.
     - According to https://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Systemd you should also BuildRequire "systemd".

[!]: Package contains systemd file(s) if in need.
     - Please add also the template unit dhcpcd@.service

[!]: Latest version is packaged.
     - latest version is 6.10.1
Comment 30 Upstream Release Monitoring 2016-02-02 03:50:33 EST
pavlix's scratch build of dhcpcd-6.10.1-1.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12784529
Comment 31 Upstream Release Monitoring 2016-02-02 04:08:04 EST
pavlix's scratch build of dhcpcd-6.10.1-1.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12784685
Comment 32 Pavel Šimerda (pavlix) 2016-02-03 03:16:43 EST
Spec URL: http://pavlix.fedorapeople.org//dhcpcd.spec
SRPM URL: http://pavlix.fedorapeople.org//dhcpcd-6.10.1-1.fc24.src.rpm

Description:
The dhcpcd package provides a minimalistic network configuration daemon
that supports IPv4 and IPv6 configuration including configuration discovery
through NDP, DHCPv4 and DHCPv6 protocols.
Comment 33 Upstream Release Monitoring 2016-02-03 04:18:56 EST
pavlix's scratch build of dhcpcd-6.10.1-2.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12799555
Comment 34 Pavel Šimerda (pavlix) 2016-02-03 05:01:40 EST
Spec URL: http://pavlix.fedorapeople.org//dhcpcd.spec
SRPM URL: http://pavlix.fedorapeople.org//dhcpcd-6.10.1-2.fc24.src.rpm

Description:
The dhcpcd package provides a minimalistic network configuration daemon
that supports IPv4 and IPv6 configuration including configuration discovery
through NDP, DHCPv4 and DHCPv6 protocols.
Comment 35 Pavel Šimerda (pavlix) 2016-02-03 05:12:12 EST
(In reply to Tomas Hozza from comment #29)
> Issues
> ------
> [!]: Requires correct, justified where necessary.
>      - According to
> https://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Systemd you
> should also BuildRequire "systemd".

We depend on systemd-devel.

> [!]: Package contains systemd file(s) if in need.
>      - Please add also the template unit dhcpcd@.service

I'm not sure this is useful at all, NetworkManager also doesn't have @.service unit, but it's there now.

> [!]: Latest version is packaged.
>      - latest version is 6.10.1

Latest version is used now.
Comment 36 Tomáš Hozza 2016-02-09 06:18:34 EST
(In reply to Pavel Šimerda (pavlix) from comment #35)
> (In reply to Tomas Hozza from comment #29)
> > Issues
> > ------
> > [!]: Requires correct, justified where necessary.
> >      - According to
> > https://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Systemd you
> > should also BuildRequire "systemd".
> 
> We depend on systemd-devel.

That does not solve the problem, since systemd-devel does NOT have any dependency on systemd package.

systemd package ships "/usr/lib/rpm/macros.d/macros.systemd" which defines the systemd RPM macros, therefore you MUST add the dependency.

http://koji.fedoraproject.org/koji/fileinfo?rpmID=7008036&filename=/usr/lib/rpm/macros.d/macros.systemd
 
> > [!]: Package contains systemd file(s) if in need.
> >      - Please add also the template unit dhcpcd@.service
> 
> I'm not sure this is useful at all, NetworkManager also doesn't have
> @.service unit, but it's there now.
> 
> > [!]: Latest version is packaged.
> >      - latest version is 6.10.1
> 
> Latest version is used now.
Comment 37 Upstream Release Monitoring 2016-02-09 06:35:54 EST
pavlix's scratch build of dhcpcd-6.10.1-3.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12915420
Comment 38 Pavel Šimerda (pavlix) 2016-02-09 07:00:13 EST
Spec URL: http://pavlix.fedorapeople.org//dhcpcd.spec
SRPM URL: http://pavlix.fedorapeople.org//dhcpcd-6.10.1-3.fc24.src.rpm

Description:
The dhcpcd package provides a minimalistic network configuration daemon
that supports IPv4 and IPv6 configuration including configuration discovery
through NDP, DHCPv4 and DHCPv6 protocols.
Comment 39 Tomáš Hozza 2016-02-09 09:40:30 EST
All issues have been resolved.

The package is APPROVED!
Comment 40 Gwyn Ciesla 2016-02-15 10:11:13 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/dhcpcd

Note You need to log in before you can comment on or make changes to this bug.